;Random instance teleporter

;DWORD [obj] = VTable Pointer
;DWORD [obj+4] = n/a
;DWORD [obj+8] = string name ID of instance to teleport
;DWORD [obj+12] = number of destination entries
;16 (max) x BYTE = each byte contains flags
;                        determining type of Axx entry
;                        bit 0 = Type
;                        bit 1 = OnTerrain
;                        bit 2 = SetOrientation

struct CAT114
       lpVTable 		dd	?
       refCount 		dd	?
       InstanceNameID		dd	?
       DestEntriesCount 	dd	?
ends

align 16
;==========================================================
AT114MAIN:
;==========================================================
push ebp
mov ebp,esp
sub esp,24
push esi
push edi
push ebx
mov esi,ecx

	mov eax,[esi+AT114Instance.TotalProbabilityCount]
	test eax,eax
	     jz AT114MAIN_EXIT
	stdcall GetRandomNumber,eax

	mov edx,[esi+AT114Instance.lpGroupsProbabilitiesList]
	AT114MAIN_GetRandInstanceLoop:
	sub eax,[edx]
	    jbe AT114MAIN_GetRandInstanceLoop_Exit
	add edx,4
	jmp AT114MAIN_GetRandInstanceLoop
	AT114MAIN_GetRandInstanceLoop_Exit:

	sub edx,[esi+AT114Instance.lpGroupsProbabilitiesList]
	mov eax,edx
	shr eax,2
	inc eax
	mov [ebp-24],eax		;store group number
	mov eax,[esi+AT114Instance.NumberOfInstances]
	mul edx
	mov edx,eax
	shr eax,2
	add eax,[esi+AT114Instance.lpGroupLocationFlags]
	add edx,[esi+AT114Instance.lpGroupData]
	mov [ebp-4],eax     ;[ebp-4] = base index for flags
	mov [ebp-8],edx     ;[ebp-8] = base index for pointers

	xor ebx,ebx
	mov edi,AT18_SIM_OBJECT

	AT114MAIN_TELEPORTLOOP:

	mov ecx,[ebp-4]
	mov al,[ebx+ecx]	 ;flags
	test al,AT114_LOC_ENTRYVALID
	     jz AT114MAIN_NOTELEPORT

	test al,AT114_LOC_USEHEIGHTRELATIVE
	setnz cl
	test al,AT114_LOC_USEONTERRAIN
	setnz dl
	mov [edi+CTeleportAction.HeightRelativeBOOL],cl
	mov [edi+CTeleportAction.OnTerrainBOOL],dl
	test al,AT114_LOC_USESETPOSITION
	setnz cl
	test al,AT114_LOC_USESETORIENTATION
	setnz dl
	mov [edi+CTeleportAction.SetPositionBOOL],cl
	mov [edi+CTeleportAction.SetOrientationBOOL],dl

	mov ecx,[ebp-8]
	mov edx,[ebx*4+ecx]	  ;pointer
	test al,AT114_LOC_USEDESTOBJECT
	     jz AT114MAIN_NoDestObject
;use destination object for location values

	mov eax,[LocationADDR]
	push edx
	mov ecx,[eax]
	call [GETOBJFROMSTRINGIDPROC]	    ;should check if null
	lea ecx,[ebx+1]
	test eax,eax
	mov edx,[ebp-24]		    ;group number in case of error
	mov [AT114_LastError],AT114Error_RT_InvalidDestObj
	mov [AT114_LastError_DWORDParam1],ecx
	mov [AT114_LastError_DWORDParam2],edx
	     jz AT114MAIN_ERROR
	push esi
	push edi
	lea esi,[eax+CInstance.Location]
	lea edi,[edi+CTeleportAction.TargetInstanceLocationSet]
	mov ecx,7
	rep movsd
	pop edi
	pop esi
	jmp AT114MAIN_DoTeleport

;use X,Y,Z location values
	AT114MAIN_NoDestObject:

	cmp [edi+CTeleportAction.SetPositionBOOL],1
	    jnz AT114MAIN_NoXYZPositionSet
	    mov eax,[edx]
	    mov ecx,[edx+4]
	    mov [edi+CTeleportAction.TargetInstanceLocationSet.X],eax
	    mov [edi+CTeleportAction.TargetInstanceLocationSet.Y],ecx
	    mov eax,[edx+8]
	    mov [edi+CTeleportAction.TargetInstanceLocationSet.Z],eax
	    add edx,12
	AT114MAIN_NoXYZPositionSet:

	cmp [edi+CTeleportAction.SetOrientationBOOL],1
	    jnz AT114MAIN_NoXYZOrientationSet
	    mov eax,[edx]
	    mov ecx,[edx+4]
	    mov [edi+CTeleportAction.TargetInstanceOrientationSet.W],eax
	    mov [edi+CTeleportAction.TargetInstanceOrientationSet.X],ecx
	    mov eax,[edx+8]
	    mov ecx,[edx+12]
	    mov [edi+CTeleportAction.TargetInstanceOrientationSet.Y],eax
	    mov [edi+CTeleportAction.TargetInstanceOrientationSet.Z],ecx
	AT114MAIN_NoXYZOrientationSet:

	AT114MAIN_DoTeleport:
	mov eax,[esi+AT114Instance.lpInstanceList]
	mov edx,[ebx*4+eax]
	mov [edi+CTeleportAction.RefCount],0
	mov [edi+CTeleportAction.TargetInstanceNameID],edx
	mov eax,[edi]
	mov ecx,edi
	call [eax+ICAction.MainProc]

	AT114MAIN_NOTELEPORT:

	inc ebx
	cmp ebx,[esi+AT114Instance.NumberOfInstances]
	    jb AT114MAIN_TELEPORTLOOP


AT114MAIN_EXIT:
pop ebx
pop edi
pop esi
mov esp,ebp
pop ebp
ret
;*/

AT114MAIN_ERROR:
	mov esi,AT114Error_RT_Main
	mov edi,AT114_MessageBuffer
	call TransferString
	mov [AT114_TempVar],esp
	invoke sprintf,edi,[AT114_LastError],[AT114_LastError_DWORDParam1],\
	       [AT114_LastError_DWORDParam2],[AT114_LastError_DWORDParam3],\
	       [AT114_LastError_DWORDParam4],[AT114_LastError_DWORDParam5]
	add eax,(AT114Error_RT_Main_end-AT114Error_RT_Main)
	mov esp,[AT114_TempVar]
	stdcall WriteLogFileInGame,AT114_MessageBuffer,eax

	xor eax,eax
	mov DWORD [eax],0

pop ebx
pop edi
pop esi
mov esp,ebp
pop ebp
ret

align 16
;==========================================================
AT114_REINIT:
;==========================================================
mov eax,[esp+4]
ret 4

align 16
;====================================================================
_AT114Init:
;====================================================================

include 'AT114_RandomizedInstanceTeleport_INIT.inc'