;============================================================
;MAIN CPARTICLES COLOR MODIFICATION CODE
;============================================================

;============================================================
CParticlesEndLevelLoad:
;============================================================
;most other CParticles-related values are set in PRELEVELLOAD.inc

cmp [NewGRFLoadDetected],FALSE
    jz NoCParticlesSaveGameDefaultColors_precall
	call CParticlesSaveGameDefaultColors   ;MUST SAVE COLORS FOR NEW GRF LOADS ONLY
					       ;Will save default colors and possible changes
					       ;made by CParticles class script (to 6 default types only)
NoCParticlesSaveGameDefaultColors_precall:

	call CParticlesCopyInitColorsToCurrent
	call CParticlesApplyAT109BufferToCurrentColors
	call CParticlesColorGlobalUpdate       ;will apply Night Mode effect to default particle
					       ;colors as well as all default particle colors
					       ;supported and set by AT109
ret


;Note: The following functions are not necessarily currently used.
;============================================================
CParticlesSaveGameDefaultColors:     ;(for 6 default effects only)
;============================================================
push esi
push edi
	mov esi,CPTypeIDTable
	mov edi,CPInitialColor

	CParticlesSaveGameDefaultColors_LOOP:
	stdcall [CPARTICLESGETOBJPROC],[esi],0
	add esp,8
	mov edx,[eax+4] 		;particle type's color
	add esi,4
	mov [edi],edx
	add edi,4
	cmp esi,(CPTypeIDTable+sizeof.CParticlesDefault)
	    jb CParticlesSaveGameDefaultColors_LOOP
pop edi
pop esi
ret

;============================================================
CParticlesCopyInitColorsToCurrent:
;============================================================
push edi
push esi
	mov esi,CPInitialColor
	mov edi,CPCurrentColor
	mov ecx,(sizeof.CParticlesDefault/4)
	rep movsd
pop esi
pop edi
ret

;============================================================
CParticlesColorGlobalUpdate:
;============================================================
;uses CPCurrentColor and CPCurrentColorSub structs to set new color values
push esi
push edi
push ebx

	 mov esi,CPCurrentColor
	 mov edi,CPTypeIDTable
	 mov ebx,CPCurrentColorMax

	 CParticlesColorGlobalUpdateLoop:
	 stdcall SpanResize24BitColor,[esi],[ebx]      ;apply NIGHT mode color change
	 push eax
	 stdcall [CPARTICLESGETOBJPROC],[edi],0        ;get CParticles object
	 add esp,8
	 add esi,4
	 pop ecx
	 add ebx,4
	 add edi,4
	 cmp esi,(CPCurrentColor+sizeof.CParticlesDefault)
	 mov [eax+4],ecx			   ;update this particle type's color
	     jb CParticlesColorGlobalUpdateLoop

pop ebx
pop edi
pop esi
ret

;============================================================
CParticlesSetUniMaskSelective:	       ;sets new color masks for designated particle types
;============================================================
;edx = flags that designate which particle color mask to set
;eax = color sub (24-bit 00RRGGBBh)

push edi
	 mov edi,CPCurrentColorMax
	 mov ecx,(sizeof.CParticlesDefault/4)
	 CParticlesSetUniMaskSelectiveLoop:
	 test dl,1
	      jz CParticlesDoNotSetUniMask
	      mov [edi],eax
	 CParticlesDoNotSetUniMask:
	 shr edx,1
	 add edi,4
	 loop CParticlesSetUniMaskSelectiveLoop
pop edi
ret

;============================================================
CParticlesResetMaxColorsBuffer:
;============================================================
push edi
	 mov edi,CPCurrentColorMax
	 mov eax,00FFFFFFh
	 mov ecx,(sizeof.CParticlesDefault/4)
	 rep stosd
pop edi
ret

;============================================================
CParticlesResetAT109Buffer:
;============================================================
push edi
	 mov edi,CPAT109Color
	 mov eax,0FF000000h			;(no-color indicator)
	 mov ecx,(sizeof.CParticlesDefault/4)
	 rep stosd
pop edi
ret

;============================================================
CParticlesApplyAT109BufferToCurrentColors:
;============================================================
push esi
push edi

	 mov esi,CPAT109Color
	 mov edi,CPCurrentColor
	 mov ecx,(sizeof.CParticlesDefault/4)
	 mov edx,0FF000000h			;(no-color indicator)

	 CParticlesApplyAT109BufferToCurrentColors_LOOP:
	 mov eax,[esi]
	 cmp eax,edx
	     jz NoAT109DefColorToSet
	     mov [edi],eax
	 NoAT109DefColorToSet:
	 add esi,4
	 add edi,4
	 loop CParticlesApplyAT109BufferToCurrentColors_LOOP
pop edi
pop esi
ret

;============================================================
CParticlesInitTypeIDTable:
;============================================================
	 stdcall [CPARTICLESENCNAMEPROC],CPSTR_Blood
	 add esp,4
	 mov [CPTypeIDTable.Blood],eax

	 stdcall [CPARTICLESENCNAMEPROC],CPSTR_Bleed
	 add esp,4
	 mov [CPTypeIDTable.Bleed],eax

	 stdcall [CPARTICLESENCNAMEPROC],CPSTR_Water
	 add esp,4
	 mov [CPTypeIDTable.Water],eax

	 stdcall [CPARTICLESENCNAMEPROC],CPSTR_Terrain
	 add esp,4
	 mov [CPTypeIDTable.Terrain],eax

	 stdcall [CPARTICLESENCNAMEPROC],CPSTR_TerrainSand
	 add esp,4
	 mov [CPTypeIDTable.TerrainSand],eax

	 stdcall [CPARTICLESENCNAMEPROC],CPSTR_MetalHard1
	 add esp,4
	 mov [CPTypeIDTable.MetalHard1],eax

ret

;============================================================
CParticlesFindTypeIDInTable:	      ;edx = type ID
;============================================================
;returns index into default buffers (no base), or -1 if not found

	 mov ecx,(sizeof.CParticlesDefault/4)
	 mov eax,CPTypeIDTable
	 CParticlesFindTypeIDInTable_LOOP:
	 cmp edx,[eax]
	     jz CParticlesFindTypeIDInTable_FOUND
	 add eax,4
	 loop CParticlesFindTypeIDInTable_LOOP
	 mov eax,-1
ret

CParticlesFindTypeIDInTable_FOUND:
	 sub eax,CPTypeIDTable
ret

