;========================================================
;MAIN FOG AND SKY MOD CODE/FUNCTIONS
;========================================================

;========================================================
INTERCEPTPROC AT05FOGMAINPROCSUBSTITUTE     ;ecx = AT05 object
;========================================================
;This saves every new fog color set by the level's script via
;AT05 and sets the new color

	push ecx
	push esi
	push edi
	lea esi,[ecx+4]
	mov edi,FogTempObj+4
	mov ecx,5
	rep movsd		    ;copy AT05 object without VTable (simple - no sub-classes)

;fog color check
	mov ecx,FogTempObj
	test BYTE [ecx+08],CSETFOG_USE_RGB	     ;are we setting new fog color???
	     jz NO_AT05FOGMAINPROCSUBSTITUTENEWCODE
	test [NIGHT_enabled],1
	     mov [AT05FogWithColorModRunOnceInLevel],TRUE
	     jz NO_AT05FOGMAINPROCSUBSTITUTENEWCODE
	     mov eax,[ecx+0Ch]		      ;SAVE NEW FOG COLOR
	     mov edx,[NIGHT_FogColorCurrent]
	     mov [FogColor_saved],eax
	     mov [ecx+0Ch],edx		      ;set new fog color
	NO_AT05FOGMAINPROCSUBSTITUTENEWCODE:

;fogpower check
	test BYTE [ecx+08],CSETFOG_USE_FOGPOWER
	     jz NO_AT05FOGMAIN_FOGPOWER
	     mov eax,[ecx+CSetFogAction.FogPower]

	     test [NIGHT_enabled],1
		  mov edx,[NIGHT_FogPower]
		  jz NO_AT05FOGMAIN_FOGPOWER_NIGHT
		  cmp edx,-1.000000
		      jz NO_AT05FOGMAIN_FOGPOWER_NIGHT
		      mov eax,edx
	     NO_AT05FOGMAIN_FOGPOWER_NIGHT:

	     test [DISABLE_GAME_FOG],1
		  jz NO_AT05FOGMAIN_FOGPOWER_NULL
		  mov eax,[FogSettings_ForcedFogPowerValue]
	     NO_AT05FOGMAIN_FOGPOWER_NULL:

	     mov [ecx+CSetFogAction.FogPower],eax
	NO_AT05FOGMAIN_FOGPOWER:

;foghalf check
	test BYTE [ecx+08],CSETFOG_USE_FOGHALF
	     jz NO_AT05FOGMAIN_FOGHALF
	     mov eax,[ecx+CSetFogAction.FogHalf]

	     test [NIGHT_enabled],1
		  mov edx,[NIGHT_FogHalf]
		  jz NO_AT05FOGMAIN_FOGHALF
		  cmp edx,-1.000000
		      jz NO_AT05FOGMAIN_FOGHALF_NIGHT
		      mov eax,edx
	     NO_AT05FOGMAIN_FOGHALF_NIGHT:

	     test [DISABLE_GAME_FOG],1
		  jz NO_AT05FOGMAIN_FOGHALF_NULL
		  mov eax,[FogSettings_ForcedFogHalfValue]
	     NO_AT05FOGMAIN_FOGHALF_NULL:

	     mov [ecx+CSetFogAction.FogHalf],eax
	NO_AT05FOGMAIN_FOGHALF:

	call [AT05FOGMAINPROCADDR]
	pop edi
	pop esi
	pop ecx

	mov edx,[FogTempObj+4]		;save reference count in real object (don't know if necessary)
	mov [ecx+4],edx

ret

;========================================================
INTERCEPTPROC AT13SKYMAINPROCSUBSTITUTE     ;ecx = AT13 object
;========================================================
;this prevents the level script from modifying any FogNear/FogFar/Height values

	push ecx
	push esi
	push edi
	lea esi,[ecx+4]
	mov edi,SkyTempObj+4
	mov ecx,9
	rep movsd		    ;copy AT13 object without VTable (simple - no sub-classes)

	test [NIGHT_enabled],1
	mov ecx,SkyTempObj
	     jz NO_AT13SKYMAINPROCSUBSTITUTENEWCODE
	     mov eax,[NIGHT_FogNearCurrent]
	     mov edx,[NIGHT_FogFarCurrent]
	     mov [ecx+14h],eax
	     mov eax,[NIGHT_SkyHeight]
	     mov [ecx+18h],edx
	     mov [ecx+10h],eax
	NO_AT13SKYMAINPROCSUBSTITUTENEWCODE:

	call [AT13SKYMAINPROCADDR]
	pop edi
	pop esi
	pop ecx

	mov edx,[SkyTempObj+4]		;save reference count in real object (don't know if necessary)
	mov [ecx+4],edx
ret

;========================================================
SetSkyFogColorNearFarInit:
;========================================================
push esi
push edi

;-------------
;SKY INIT
;-------------

cmp [NIGHT_enabled],FALSE
    jz NoSetSkyRenderInit

;set initial Sky FogNear/FogFar/Height settings (whether previously set or not)

	mov edi,SkyTempObj+4
	xor eax,eax
	mov ecx,9
	rep stosd

	mov ecx,SkyTempObj
	mov eax,[NIGHT_FogNearCurrent]
	mov edx,[NIGHT_FogFarCurrent]
	mov [ecx+14h],eax
	mov eax,[NIGHT_SkyHeight]
	mov [ecx+18h],edx
	mov [ecx+10h],eax
	mov DWORD [ecx+8],2+4+8 	;these bits tell AT13 to only change FogNear/FogFar/Height
	call [AT13SKYMAINPROCADDR]


;set initial Ambient Light setting (if applicable)
	fld [NIGHT_AmbientLight]
	fcomp [float_minusone]
	fstsw ax
	test ah,40h
	     jnz NoSetSkyRenderInit
	mov edi,RenderTempObj+4
	xor eax,eax
	mov ecx,14
	rep stosd
	mov ecx,RenderTempObj
	mov eax,[NIGHT_AmbientLight]
	mov DWORD [ecx+8],1		;set only ambient light
	mov [ecx+0Ch],eax
	call [AT06RENMAINPROCADDR]

NoSetSkyRenderInit:

;-------------
;FOG INIT
;-------------

	mov edi,FogTempObj+4
	xor eax,eax
	mov ecx,5
	rep stosd
	mov ecx,FogTempObj

;fog color
cmp [AT05FogWithColorModRunOnceInLevel],TRUE	 ;The following code is only necessary if AT05 was not run upon CStartTrigger (maybe error)
    jz NoSetFogColorInit
	mov eax,[DEFAULT_FOG_COLOR_VALUE]
	cmp [NIGHT_enabled],FALSE
	    jz NoSetSkyNearFarInitSubColor
	    mov eax,[NIGHT_FogColorCurrent]
	NoSetSkyNearFarInitSubColor:
	or DWORD [ecx+8],CSETFOG_USE_RGB	    ;this bit tells AT05 to only change fog color
	mov [ecx+0Ch],eax			    ;new fog colors (based on previous)
NoSetFogColorInit:

;fog power and fog half for Night Mode
	test [NIGHT_enabled],1
	     jz NoSetFogPowerHalfInit
	mov eax,[NIGHT_FogPower]
	mov edx,[NIGHT_FogHalf]
	cmp eax,-1.00000
	    jz NoSetSkyNearFarInitFogPower
	    or DWORD [ecx+8],CSETFOG_USE_FOGPOWER
	    mov [ecx+CSetFogAction.FogPower],eax
	NoSetSkyNearFarInitFogPower:
	cmp edx,-1.00000
	    jz NoSetSkyNearFarInitFogHalf
	    or DWORD [ecx+8],CSETFOG_USE_FOGHALF
	    mov [ecx+CSetFogAction.FogHalf],edx
	NoSetSkyNearFarInitFogHalf:
NoSetFogPowerHalfInit:

;fog power and fog half for DISABLE_GAME_FOG
	test [DISABLE_GAME_FOG],1
	     jz NoSetFogPowerHalfInit_Null
	     or DWORD [ecx+8],CSETFOG_USE_FOGPOWER+CSETFOG_USE_FOGHALF
	     mov eax,[FogSettings_ForcedFogPowerValue]
	     mov [ecx+CSetFogAction.FogPower],eax
	     mov eax,[FogSettings_ForcedFogHalfValue]
	     mov [ecx+CSetFogAction.FogHalf],eax
NoSetFogPowerHalfInit_Null:

	cmp DWORD [ecx+8],0
	    jz NoAT05FOGMAINPROCADDR_InitCall  ;only call if we're actually changing something
	call [AT05FOGMAINPROCADDR]
	NoAT05FOGMAINPROCADDR_InitCall:


pop edi
pop esi
ret

;========================================================
INTERCEPTPROC AT06RENDMAINPROCSUBSTITUTE     ;ecx = AT06 object
;========================================================
	push ecx
	push esi
	push edi
	lea esi,[ecx+4]
	mov edi,RenderTempObj+4
	mov ecx,14
	rep movsd		    ;copy AT06 object without VTable (simple - no sub-classes)

	test [NIGHT_enabled],1
	mov ecx,RenderTempObj
	     jz NO_AT06RENDMAINPROCSUBSTITUTENEWCODE
	     fld [NIGHT_AmbientLight]
	     fcom [float_minusone]
	     fstsw ax
	     test ah,40h
		  jnz AmbientLightValueSetToNoModify
		  fst DWORD [ecx+0Ch]
	     AmbientLightValueSetToNoModify:
	     fstp st0
	NO_AT06RENDMAINPROCSUBSTITUTENEWCODE:

	call [AT06RENMAINPROCADDR]
	pop edi
	pop esi
	pop ecx

	mov edx,[RenderTempObj+4]	   ;save reference count in real object (don't know if necessary)
	mov [ecx+4],edx
ret

;========================================================
INTERCEPTPROC DEFAULTFOGCOLORSETINTERCEPT	;must preserve eax
;========================================================
cmp [NIGHT_enabled],FALSE
    mov edx,[CURRENTFOGCOLORADDR]
    jz DEFAULT_FOGCOLORSET
    mov ecx,[NIGHT_FogColorCurrent]
    mov [edx],ecx
ret

DEFAULT_FOGCOLORSET:
    mov ecx,[DEFAULT_FOG_COLOR_VALUE]
    mov [edx],ecx
ret


