;===========================================================
;NIGHT MODE OBJECT TELEPORTATION
;===========================================================

DoNightModeTeleportsInit:
push ebp
push edi
push esi
push ebx

;get INI filename and path
	mov edi,[MapsPathSize]
	mov esi,[LEVELNAME_OBJ] 	 ;SCN level name
	add edi,MapsDirBuffer
	mov DWORD [edi],'NMD\'
	add edi,4
	call TransferString
	mov DWORD [edi-4],'.INI'	;modify extension

	mov ebx,1

;check if night mode enabled and set corresponding string in esi
	cmp [NIGHT_enabled],FALSE
	mov esi,NORMALMODELOC_STRING
	    jz DoNightModeTeleportsInit_LOOP
	    mov esi,NIGHTMODELOC_STRING

;main loop
	DoNightModeTeleportsInit_LOOP:

;get current instance name (at stack_ext_buffer+100)
	invoke wsprintf,stack_ext_buffer,INSTANCE_STRING,ebx
	add esp,12

	invoke GetPrivateProfileString,STRING_GENERAL,stack_ext_buffer,\
		  NONE_STRING,stack_ext_buffer+100,200,MapsDirBuffer
	cmp DWORD [stack_ext_buffer+100],'none'
	    jz DoNightModeTeleportsInit_LOOP_END	;quit if no more instances in order

	invoke wsprintf,stack_ext_buffer,esi,ebx
	add esp,12

;get location values (at stack_ext_buffer+300)
	invoke GetPrivateProfileString,STRING_GENERAL,stack_ext_buffer,\
		  NONE_STRING,stack_ext_buffer+300,100,MapsDirBuffer
	cmp DWORD [stack_ext_buffer+300],'none'
	    jz DoNightModeTeleportsInit_LOOP_NOLOC

	    mov eax,stack_ext_buffer+100
	    call GetInstanceFromStringGlobal_CBD
	    test eax,eax
	    mov edi,eax
		jz DoNightModeTeleportsInit_LOOP_NOLOC

	    mov edx,stack_ext_buffer
	    xor eax,eax
	    lea ecx,[edx+4]
	    mov [edx],eax
	    mov [edx+4],eax
	    mov [edx+8],eax
	    lea eax,[edx+8]

	    mov ebp,esp
	    invoke sscanf,stack_ext_buffer+300,FLOAT_RETRIEVE_STRING,edx,ecx,eax
	    mov esp,ebp

	    mov ecx,edi
	    mov edi,stack_ext_buffer
	    mov eax,[ecx+3Ch]		;keep initial FACING values for object
	    mov edx,[ecx+40h]
	    mov [edi+0Ch],eax
	    mov [edi+10h],edx
	    mov eax,[ecx+44h]
	    mov edx,[ecx+48h]
	    mov [edi+14h],eax
	    mov [edi+18h],edx

;teleport instance
	    push 0
	    mov eax,[ecx]
	    push edi
	    call DWORD [eax+ICInstance.Teleport]

	DoNightModeTeleportsInit_LOOP_NOLOC:
	inc ebx
	    jnz DoNightModeTeleportsInit_LOOP
	DoNightModeTeleportsInit_LOOP_END:

	mov ecx,[MapsPathSize]
	mov BYTE [ecx+MapsDirBuffer],0

pop ebx
pop esi
pop edi
pop ebp
ret