
;=======================================================
; class CGameState (unofficial)
;=======================================================
sizeof.CGameState equ 54h

typedef struct CGameState {
 DWORD Unknown1;
 LPCPARTITIONSPACE lpPartitionSpace1;
 LPCPARTITIONSPACE lpPartitionSpace2;
 LPCPARTITIONSPACE lpPartitionSpace3;
 LPCPARTITIONSPACE lpPartitionSpace4;
 LPCCAMERA lpCamera;
 ...
}

#label CGameState::CGameState()_0 = 0x005E73A0, 0, 0, 0
#label CGameState::InitSubsystems()_0 = 0x005E7720, 0, 0, 0

CGameState CGameState::CGameState(
);

Constructor calls CGameState::InitSubsystems()
Is used when game is first started.

VOID CGameState::InitSubsystems(
);

Inits all subsystems and partition spaces, stores
partition spaces in CGameState instance and
stores subsystem instances in their respective
global variables.

;=======================================================
; class CPartitionSpace
;=======================================================
sizeof.CPartitionSpace equ 48h

#label CPartitionSpace::CPartitionSpace()_0 = 0x00488340
#label CPartitionSpace::CPartitionSpace()_1 = 0x004883B0

CPartitionSpace CPartitionSpace::CPartitionSpace(
);

CPartitionSpace CPartitionSpace::CPartitionSpace(
 UNKNOWN Param1
);

;=======================================================
; class CDaemon
;=======================================================
sizeof.CDaemon equ 50h

#label CDaemon::CDaemon()_0 = 0x004578C0, 0, 0, 0

CDaemon CDaemon::CDaemon(
);

;=======================================================
; class CAudioDaemon
;=======================================================

#label CAudioDaemon::CAudioDaemon()_0 = 0x0041A790, 0, 0, 0
#label CAudioDaemon::~CAudioDaemon()_0 = 0x0041AA90, 0, 0, 0
#label CAudioDaemon::TPAInitSingleStdFile()_2 = 0x0041DB60, 0x0041DA50, 0x0041DBF0, 0x0041DBA0
#label CAudioDaemon::TPAUninitAllStdFiles()_0 = 0x0041DAF0, 0x0041D9E0, 0x0041DB80, 0x0041DB30

CAudioDaemon CAudioDaemon::CAudioDaemon(
);

VOID CAudioDaemon::~CAudioDaemon(
);

CPackFile CAudioDaemon::TPAInitSingleStdFile(
 LPSTRING lpFileName,	// filename only, will be appended to path
 INT MaxOpenStreams
); 

a.k.a. TPAStdInitProc
Inits a single original game TPAs. Called three times, one for each original TPA.
Calls CPackFile::CPackFile(). Is basically a wrap.

VOID CAudioDaemon::TPAUninitAllStdFiles(
);

a.k.a. TPAStdUnInitProc
Frees all standard original game TPAs. Called only once (at game exit).

;=======================================================
; class CPhysicsSystem
;=======================================================
sizeof.CPhysicsSystem equ 8Ch

#label CPhysicsSystem::CPhysicsSystem()_0 = 0x004B3A70, 0, 0, 0
#label CPhysicsSystem::~CPhysicsSystem()_0 = 0x004B3C10, 0, 0, 0
#label CPhysicsSystem::StepCallback()_virtual_1 = 0x004B42A0, 0, 0, 0
#label CPhysicsSystem::UpdateMoveActiveInstanceBuffer()_0 = 0x004B4AE0
#label CPhysicsSystem::GetNumActiveAnimates()_0 = 0x004B3810
#label CPhysicsSystem::GetNumActiveBoxes()_0 = 0x004B37C0
#label CPhysicsSystem::GetNumActiveInstancesTotal()_0 = 0x004B4B50
#label CPhysicsSystem::GetActiveAnimateIndex()_1 = 0x004B3DD0

CPhysicsSystem CPhysicsSystem::CPhysicsSystem(
);

VOID CPhysicsSystem::~CPhysicsSystem(
);

VOID CPhysicsSystem::StepCallback(
 LPCMESSAGE lpSourceMessage	// message that caused callback to happen
);

; the following loop goes through the same buffer as
; UpdateMoveInstanceBuffer(), just uses a different offset
; in the structures for some obscure reason.
#label MainPhysicsBufferInstanceBoxLoop = 0x004B42B5

VOID CPhysicsSystem::UpdateMoveActiveInstanceBuffer(
);

#label ActiveAnimatesLoop = 0x004B4B0C

Scans through a very large buffer at fixed address
that contains a series of 0x1064-byte structures,
one per instance involved in physics.
It calls PhysicsDoInstanceMoveByIndex() for each
valid instance structure (for each active CBoundaryBox)
and then does a loop for currently 'active animates' (8 max).

INT CPhysicsSystem::GetNumActiveAnimates(
);

Scans through the 'active animates' buffer, which
is apparently maxed at 8 instances because the loop
is capped at 8 iterations. Calls PhysicsGetActiveAnimateByIndex().

INT CPhysicsSystem::GetNumActiveBoxes(
);

Goes through buffer of 0x1064-byte structures in active boxes
buffer, and counts structures who's first members aren't null.

INT CPhysicsSystem::GetNumInstancesTotal(
);

does (C++):
return ( GetNumActiveAnimates() + GetNumActiveBoxes() );

Seems to count number of instances (boundary boxes, animals, player, etc.)
that are currently involved with the physics system. Even though animals
and player inst. are counted under animates list, their physics boxes
are present in the active boxes list and are counted as well.

Note: The part of code where this function is called doesn't
use return value; must have been used for diagnostics, during dev.

INT CPhysicsSystem::GetActiveAnimateIndex(
 LPCANIMATE lpInstanceToFind
);

This checks the 'active animate' physics list for the specified
instance and returns the index from buffer start (0 to 7) if
found. If not found, returns -1. Uses PhysicsGetActiveAnimateByIndex().



;=======================================================
; class CVideoOverlay
;=======================================================
sizeof.CVideoOverlay equ 6Ch

#label CVideoOverlay::CVideoOverlay()_0 = 0x00457920, 0, 0, 0
#label CVideoOverlay::~CVideoOverlay()_0 = 0x00457A60, 0, 0, 0

CVideoOverlay CVideoOverlay::CVideoOverlay(
);

VOID CVideoOverlay::~CVideoOverlay(
);

;=======================================================
; class CTexturePageManager
;=======================================================

#label CTexturePageManager::CTexturePageManager()_0 = 0x0048AD20, 0, 0, 0
#label CTexturePageManager::~CTexturePageManager()_0 = 0x0048AD90, 0, 0, 0

CTexturePageManager CTexturePageManager::CTexturePageManager(
);

CTexturePageManager CTexturePageManager::~CTexturePageManager(
);

;=======================================================
; class CInputDeemone
;=======================================================
sizeof.CInputDeemone equ 88h

#label CInputDeemone::CInputDeemone()_3 = 0x005DB880, 0, 0, 0
#label CInputDeemone::~CInputDeemone()_0 = 0x005DB9E0, 0, 0, 0

CInputDeemone CInputDeemone::CInputDeemone(
 UNKNOWN Param1,
 UNKNOWN Param2,
 UNKNOWN Param3
);

VOID CInputDeemone::~CInputDeemone(
); // Most likely a destructor, maybe constructor.

;=======================================================
; class CConsoleBuffer
;=======================================================

#label CConsoleBuffer::CConsoleBuffer()_2 = 0x005DCBE0, 0, 0, 0

CConsoleBuffer CConsoleBuffer::CConsoleBuffer(
 UNKNOWN Param1,
 UNKNOWN Param2
);

;=======================================================
; class CConsoleEx
;=======================================================

#label CConsoleEx::CConsoleEx()_4 = 0x005DD020, 0, 0, 0
#label CConsoleEx::~CConsoleEx()_0 = 0x005DD0B0, 0, 0, 0

CConsoleEx CConsoleEx::CConsoleEx(
 UNKNOWN Param1,
 UNKNOWN Param2,
 UNKNOWN Param3,
 UNKNOWN Param4
);

VOID CConsoleEx::~CConsoleEx(
);

;=======================================================
; class CAnimations
;=======================================================
sizeof.CAnimations equ 58h

CAnimations is used for textures animations.

#label CAnimations::CAnimations()_0 = 0x006023D0, 0, 0, 0
#label CAnimations::~CAnimations()_0 = 0x00602560, 0, 0, 0

CAnimations CAnimations::CAnimations(
);

VOID CAnimations::~CAnimations(
);

;=======================================================
; class CCameraPrime
;=======================================================
sizeof.CCameraPrime equ 54h

#label CCameraPrime::CCameraPrime()_0 = 0x006070C0, 0, 0, 0
#label CCameraPrime::~CCameraPrime()_0 = 0x00607200, 0, 0, 0

CCameraPrime CCameraPrime::CCameraPrime(
);

VOID CCameraPrime::~CCameraPrime(
);

;=======================================================
; class CRenderDB
;=======================================================
sizeof.CRenderDB equ 60h

#label CRenderDB::CRenderDB()_1 = 0x00607B10, 0, 0, 0
#label CRenderDB::~CRenderDB()_0 = 0x00607CA0, 0, 0, 0

CRenderDB CRenderDB::CRenderDB(
 UNKNOWN Param1
); // "Render DBase" subsystem constructor.

VOID CRenderDB::~CRenderDB(
);

;=======================================================
; class CAISystem
;=======================================================
sizeof.CAISystem equ 31D0h

#label CAISystem::CAISystem()_1 = 0x00609640, 0, 0, 0
#label CAISystem::StepCallback()_virtual_1 = 0x0060A490, 0, 0, 0x0060D820
#label CAISystem::FreezeAnimal()_1 = 0x00609CB0
#label CAISystem::Update()_0 = 0x0060A7B0
#label CAISystem::UpdateNextAnimal()_0 = 0x0060A0C0
#label CAISystem::OutputMessage()_1 = 0x0060A990
#label CAISystem::GetDinoVocalValue()_3 = 0x0060AFE0, 0x005D9140, 0x0060D8A0, 0x0060E380
#label CAISystem::GetDinoVocalNotNullWrap()_3 = 0x0060B010
#label CAISystem::GetCurrentAnimalLocation()_1 = 0x0060A9B0
#label CAISystem::~CAISystem()_0 = 0x00609880, 0, 0, 0
#label CAISystem::UpdateCurrentBrain()_1 = 0x0060A100, 0, 0, 0
#label CAISystem::GetCurrentAnimal()_0 = 0x0060AC70, 0, 0, 0

CAISystem CAISystem::CAISystem(
 UNKNOWN Param1
);

VOID CAISystem::StepCallback(
 LPCMESSAGE lpSourceMessage	// message that caused callback to happen
);

Iterates dinosaur actions and sets which dinos to freeze/unfreeze.
Only one active dino is managed for every call to this function,
presumably to save on framerate.

#label TestDINOSBool = 0x0060A4AE
#label FreezeDinosLoop = 0x0060A4FD
#label CalcDistBetweenDinoAndPlayer = 0x0060A534
;#label WakeDinosLoop = 0x0060A5DF     // WRONG
#label CalcDistBetweenDinoAndPlayer = 0x0060A66C
#label CalcDistBetweenDinoAndPlayer = 0x0060A71E

VOID CAISystem::FreezeAnimal(
 LPCANIMAL lpAnimal
);

Removes animal from CAISystem active instances buffer.

VOID CAISystem::Update(
);

Updates internal time values using CTimerLocal and
calls CAISystem::UpdateNextDino()

VOID CAISystem::UpdateNextAnimal(
);

This iterates between active instances using a global
value. It processes one instance per call and updates
the global value. Thus, for 3 instances, this needs
3 calls. It jumps to CBrain::Update() with the CBrain
instance from the index-designated instance.

VOID CAISystem::OutputMessage(
 LPCTSTR lpMessageString
);

Method currently does nothing (would have been used
during development).

LPDWORD GetDinoVocalValue(
 INT Dinosaur,
 INT Vocal
); 

a.k.a. DINO_VOCAL_OFFSET_PROC
Start of value table is at [CAISystem+388h].

INT GetDinoVocalNotNullWrap(
 INT Dinosaur,
 INT Vocal
);

Calls CAISystem.GetDinoVocalValue()

LPLOCATION CAISystem::GetCurrentAnimalLocation(
 LPVOID lpLocationValueBuffer
); // returns lpLocationValueBuffer

Returns location for animal last iterated by CAISystem::UpdateNextDino().
It fetches the instance from its CBrain instance which is
stored (last iterated only) in CAISystem.

DWORD [CAISystem+31B8h] = last/currently active CBrain instance
			  (one being iterated)
DWORD [CBrain+11Ch] = associated CAnimal instance

VOID CAISystem::~CAISystem(
);


VOID CAISystem::UpdateCurrentBrain(
 LPCBRAIN lpNewBrain
);

Sets current (last) brain instance in CAISystem instance,
as well as last "synthesizer" instance and updates its
dino's physics (?).


LPCANIMAL CAISystem::GetCurrentAnimal(
);

Returns animal which current active brain belongs to.


;=======================================================
; class CBloodSplats
;=======================================================
sizeof.CBloodSplats equ 6Ch

#label CBloodSplats::CBloodSplats()_0 = 0x00623BA0, 0, 0, 0
#label CBloodSplats::~CBloodSplats()_0 = 0x00623D90, 0, 0, 0

CBloodSplats CBloodSplats::CBloodSplats(
);

VOID CBloodSplats::~CBloodSplats(
);

;=======================================================
; class CAutoGrabber
;=======================================================
sizeof.CAutoGrabber equ 60h

#label CAutoGrabber::CAutoGrabber()_0 = 0x00635EA0, 0, 0, 0
#label CAutoGrabber::~CAutoGrabber()_0 = 0x00635FE0, 0, 0, 0

CAutoGrabber CAutoGrabber::CAutoGrabber(
);

VOID CAutoGrabber::~CAutoGrabber(
);
